## liblinear 1.6+dfsg

=== Makefile ===
CXX ?= g++
CC ?= gcc
CFLAGS = -Wall -Wconversion -O3 -fPIC
LIBS =
SHVER = 1
#LIBS = -lblas

all: train predict

lib: linear.o tron.o
	$(CXX) -shared -dynamiclib linear.o tron.o -o liblinear.so.$(SHVER)

train: tron.o linear.o train.c
	$(CXX) $(CFLAGS) -o train train.c tron.o linear.o $(LIBS)

predict: tron.o linear.o predict.c
	$(CXX) $(CFLAGS) -o predict predict.c tron.o linear.o $(LIBS)

tron.o: tron.cpp tron.h
	$(CXX) $(CFLAGS) -c -o tron.o tron.cpp

linear.o: linear.cpp linear.h
	$(CXX) $(CFLAGS) -c -o linear.o linear.cpp

clean:
	cd matlab;	make clean
	rm -f *~ tron.o linear.o train predict liblinear.so.$(SHVER)

=== matlab/Makefile ===
# This Makefile is used under Linux

MATLABDIR ?= /usr/local/matlab
CXX ?= g++
#CXX = g++-3.3
CC ?= gcc
CFLAGS = -Wall -Wconversion -O3 -fPIC -I$(MATLABDIR)/extern/include -I..

MEX = $(MATLABDIR)/bin/mex
MEX_OPTION = CC\#$(CXX) CXX\#$(CXX) CFLAGS\#"$(CFLAGS)" CXXFLAGS\#"$(CFLAGS)"
# comment the following line if you use MATLAB on a 32-bit computer
MEX_OPTION += -largeArrayDims
MEX_EXT = $(shell $(MATLABDIR)/bin/mexext)

OCTAVEDIR ?= /usr/include/octave
OCTAVE_MEX = env CC=$(CXX) mkoctfile
OCTAVE_MEX_OPTION = --mex
OCTAVE_MEX_EXT = mex
OCTAVE_CFLAGS = -Wall -O3 -fPIC -I$(OCTAVEDIR) -I..

all:	matlab

matlab:	binary

octave:
	@make MEX="$(OCTAVE_MEX)" MEX_OPTION="$(OCTAVE_MEX_OPTION)" \
	MEX_EXT="$(OCTAVE_MEX_EXT)" CFLAGS="$(OCTAVE_CFLAGS)" \
	binary

binary: train.$(MEX_EXT) predict.$(MEX_EXT) libsvmread.$(MEX_EXT) libsvmwrite.$(MEX_EXT)

train.$(MEX_EXT): train.c ../linear.h tron.o linear.o linear_model_matlab.o
	$(MEX) $(MEX_OPTION) train.c tron.o linear.o linear_model_matlab.o

predict.$(MEX_EXT): predict.c ../linear.h tron.o linear.o linear_model_matlab.o
	$(MEX) $(MEX_OPTION) predict.c tron.o linear.o linear_model_matlab.o

libsvmread.$(MEX_EXT):	libsvmread.c
	$(MEX) $(MEX_OPTION) libsvmread.c

libsvmwrite.$(MEX_EXT):	libsvmwrite.c
	$(MEX) $(MEX_OPTION) libsvmwrite.c

linear_model_matlab.o: linear_model_matlab.c ../linear.h
	$(CXX) $(CFLAGS) -c linear_model_matlab.c

linear.o: ../linear.cpp ../linear.h
	$(CXX) $(CFLAGS) -c ../linear.cpp

tron.o: ../tron.cpp ../tron.h
	$(CXX) $(CFLAGS) -c ../tron.cpp

clean:
	rm -f *~ *.o *.mex* *.obj

=== debian/changelog ===
liblinear (1.6+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #585788)
  * debian/patches:
    - 0001-Properly-build-shared-and-static-libraries-programs
    - 0002-Move-Python-bindings-to-package-liblinear

 -- Christian Kastner <debian@kvr.at>  Fri, 09 Jul 2010 21:45:57 +0200

=== debian/control ===
Source: liblinear
Priority: optional
Maintainer: Christian Kastner <debian@kvr.at>
Build-Depends:
    debhelper (>= 7.0.50~),
    python-support (>= 0.90),
    libblas-dev
Standards-Version: 3.9.0
Section: libs
Homepage: http://www.csie.ntu.edu.tw/~cjlin/liblinear/
Vcs-Git: git://scm.kvr.at/git/pkg-liblinear.git
Vcs-Browser: http://scm.kvr.at/git/?p=liblinear.git;a=summary

Package: liblinear-dev
Section: libdevel
Architecture: any
Depends:
    ${misc:Depends},
    liblinear1 (= ${binary:Version}),
    libblas-dev
Description: Development libraries and header files for LIBLINEAR
 LIBLINEAR is a library for learning linear classifiers for large scale
 applications. It supports Support Vector Machines (SVM) with L2 and L1
 loss, logistic regression, multi class classification and also Linear
 Programming Machines (L1-regularized SVMs). Its computational complexity
 scales linearly with the number of training examples making it one of
 the fastest SVM solvers around.
 .
 This package contains the header files and static libraries.

Package: liblinear1
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
Recommends:
    liblinear-tools (= ${binary:Version})
Suggests:
    liblinear-dev (= ${binary:Version})
Description: Library for Large Linear Classification
 LIBLINEAR is a library for learning linear classifiers for large scale
 applications. It supports Support Vector Machines (SVM) with L2 and L1
 loss, logistic regression, multi class classification and also Linear
 Programming Machines (L1-regularized SVMs). Its computational complexity
 scales linearly with the number of training examples making it one of
 the fastest SVM solvers around. It also provides Python bindings.
 .
 This package contains the shared libraries.

Package: liblinear-dbg
Priority: extra
Section: debug
Architecture: any
Depends:
    ${misc:Depends},
    liblinear1 (= ${binary:Version}),
    liblinear-tools (= ${binary:Version})
Description: Debugging symbols for LIBLINEAR
 LIBLINEAR is a library for learning linear classifiers for large scale
 applications. It supports Support Vector Machines (SVM) with L2 and L1
 loss, logistic regression, multi class classification and also Linear
 Programming Machines (L1-regularized SVMs). Its computational complexity
 scales linearly with the number of training examples making it one of
 the fastest SVM solvers around. It also provides Python bindings.
 .
 This package contains the debugging symbols.

Package: liblinear-tools
Section: science
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    liblinear1 (= ${binary:Version})
Recommends:
    libsvm-tools
Description: Standalone applications for LIBLINEAR
 LIBLINEAR is a library for learning linear classifiers for large scale
 applications. It supports Support Vector Machines (SVM) with L2 and L1
 loss, logistic regression, multi class classification and also Linear
 Programming Machines (L1-regularized SVMs). Its computational complexity
 scales linearly with the number of training examples making it one of
 the fastest SVM solvers around. It also provides Python bindings.
 .
 This package contains the standalone applications.

Package: python-liblinear
Section: python
Architecture: any
Depends:
    ${python:Depends},
    ${misc:Depends},
    liblinear1 (= ${binary:Version})
Description: Python bindings for LIBLINEAR
 LIBLINEAR is a library for learning linear classifiers for large scale
 applications. It supports Support Vector Machines (SVM) with L2 and L1
 loss, logistic regression, multi class classification and also Linear
 Programming Machines (L1-regularized SVMs). Its computational complexity
 scales linearly with the number of training examples making it one of
 the fastest SVM solvers around. It also provides Python bindings.
 .
 This package contains the Python bindings.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Get version numbers for SONAME from changelog
DVER = $(shell dpkg-parsechangelog | grep '^Version')
LVER = $(shell echo $(DVER) | sed -e 's/Version: \([0-9]*\)\..*/\1/')
LSUBVER = $(shell echo $(DVER) | sed -e 's/Version: .*\.\([0-9]*\).*/\1/')
export LVER
export LSUBVER

CFLAGS = -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -O0
else
    CFLAGS += -O3
ifeq (amd64,$(DEB_HOST_ARCH))
    CFLAGS += -msse
endif
endif

%:
	dh $@ 

override_dh_compress:
	dh_compress -Xexamples

override_dh_strip:
	dh_strip --dbg-package=liblinear-dbg

## liblinear 1.8%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,18 @@
 Source: liblinear
 Priority: optional
-Maintainer: Christian Kastner <debian@kvr.at>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Christian Kastner <debian@kvr.at>
+Uploaders: Chen-Tse Tsai <ctse.tsai@gmail.com>
 Build-Depends:
     debhelper (>= 7.0.50~),
-    python-support (>= 0.90),
+    python-all (>= 2.6.6-3~),
     libblas-dev
-Standards-Version: 3.9.0
+Standards-Version: 3.9.2
 Section: libs
 Homepage: http://www.csie.ntu.edu.tw/~cjlin/liblinear/
 Vcs-Git: git://scm.kvr.at/git/pkg-liblinear.git
-Vcs-Browser: http://scm.kvr.at/git/?p=liblinear.git;a=summary
+Vcs-Browser: http://scm.kvr.at/git/?p=pkg-liblinear.git;a=summary
+X-Python-Version: >= 2.5
 
 Package: liblinear-dev
 Section: libdevel
@@ -17,7 +20,7 @@
 Depends:
     ${misc:Depends},
     liblinear1 (= ${binary:Version}),
-    libblas-dev
+    libblas-dev | libatlas-dev | libblas-3gf.so
 Description: Development libraries and header files for LIBLINEAR
  LIBLINEAR is a library for learning linear classifiers for large scale
  applications. It supports Support Vector Machines (SVM) with L2 and L1
@@ -72,7 +75,7 @@
     ${shlibs:Depends},
     ${misc:Depends},
     liblinear1 (= ${binary:Version})
-Recommends:
+Suggests:
     libsvm-tools
 Description: Standalone applications for LIBLINEAR
  LIBLINEAR is a library for learning linear classifiers for large scale

## liblinear 1.8+dfsg

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,6 @@
 CFLAGS = -Wall -Wconversion -O3 -fPIC
 LIBS =
 SHVER = 1
-#LIBS = -lblas
 
 all: train predict
 
@@ -22,6 +21,7 @@
 linear.o: linear.cpp linear.h
 	$(CXX) $(CFLAGS) -c -o linear.o linear.cpp
 
+
 clean:
 	cd matlab;	make clean
 	rm -f *~ tron.o linear.o train predict liblinear.so.$(SHVER)

=== matlab/Makefile ===
--- 
+++ 
@@ -29,11 +29,11 @@
 
 binary: train.$(MEX_EXT) predict.$(MEX_EXT) libsvmread.$(MEX_EXT) libsvmwrite.$(MEX_EXT)
 
-train.$(MEX_EXT): train.c ../linear.h tron.o linear.o linear_model_matlab.o
-	$(MEX) $(MEX_OPTION) train.c tron.o linear.o linear_model_matlab.o
+train.$(MEX_EXT): train.c ../linear.h ../tron.o ../linear.o linear_model_matlab.o
+	$(MEX) $(MEX_OPTION) train.c ../tron.o ../linear.o linear_model_matlab.o
 
-predict.$(MEX_EXT): predict.c ../linear.h tron.o linear.o linear_model_matlab.o
-	$(MEX) $(MEX_OPTION) predict.c tron.o linear.o linear_model_matlab.o
+predict.$(MEX_EXT): predict.c ../linear.h ../tron.o ../linear.o linear_model_matlab.o
+	$(MEX) $(MEX_OPTION) predict.c ../tron.o ../linear.o linear_model_matlab.o
 
 libsvmread.$(MEX_EXT):	libsvmread.c
 	$(MEX) $(MEX_OPTION) libsvmread.c
@@ -44,11 +44,11 @@
 linear_model_matlab.o: linear_model_matlab.c ../linear.h
 	$(CXX) $(CFLAGS) -c linear_model_matlab.c
 
-linear.o: ../linear.cpp ../linear.h
-	$(CXX) $(CFLAGS) -c ../linear.cpp
+../linear.o:
+	cd ..; make linear.o
 
-tron.o: ../tron.cpp ../tron.h
-	$(CXX) $(CFLAGS) -c ../tron.cpp
+../tron.o: 
+	cd ..; make tron.o
 
 clean:
 	rm -f *~ *.o *.mex* *.obj

=== python/Makefile ===
all = lib

lib:
	cd ..; make lib; cd -

=== debian/changelog ===
liblinear (1.8+dfsg-5) unstable; urgency=medium

  * Add package python3-liblinear.
  * debian/control:
    - Bump Standards-Version to 3.9.6 (no changes needed)
    - Drop XS-Testsuite. dpkg now recognizes the Testsuite header, and
      dpkg-source automatically adds one when an autopkgtest suite is found
    - Add Build-Depends for dh-python
    - Add Build-Depends for python3-all-dev
    - Add X-Python3-Version of 3.0
  * debian/rules:
    - Make dh also build with dh_python3
  * debian/liblinear1.symbols: Mark symbol optimized away by GCC 5 as optional,
    thereby fixing a FTBFS. Closes: #790248
  * debian/copyright:
    - Bump copyright years

 -- Christian Kastner <debian@kvr.at>  Wed, 22 Jul 2015 17:11:54 +0200

liblinear (1.8+dfsg-4) unstable; urgency=medium

  * Migrate repo to Debian-Science at git.debian.org
  * debian/control:
    - Update Vcs-* URLs to point to new location
    - Add XS-Testsuite for autopkgtest
    - python-liblinear is arch:all, not arch:any. Thanks, Vincent Cheng
  * debian/tests/*:
    - Define an autopkgtest that runs the examples from the documentation
  * debian/patches (updated):
    - 0006-Improve-option-parsing
      Fix wrong function call in float parsing (for epsilon value, etc.). As a
      result of copy-pasta, strtol() was being used where strtof() was needed.

 -- Christian Kastner <debian@kvr.at>  Tue, 26 Aug 2014 10:35:07 -0700

liblinear (1.8+dfsg-3) unstable; urgency=low

  * debian/symbols:
    - Declare an empty virtual destructor as optional symbol; gcc-4.9 no longer
      generates it. Fixes a FTBFS. Closes: #753227
  * debian/control:
    - Add Multi-Arch fields to packages where necessary
    - Add Pre-Depends for package liblinear1
  * debian/rules:
    - Install to multi-arch destinations using DEB_HOST_MULTIARCH
  * debian/*.install:
    - Update paths as a consequence of the new install target and
      multi-arch-ification
  * debian/patches (updated):
    - 0001-Properly-build-shared-and-static-libraries-programs
      Add an install target to upstream's Makefile, with configurable
      destinations for libraries and executables

 -- Christian Kastner <debian@kvr.at>  Sat, 26 Jul 2014 23:11:03 +0200

liblinear (1.8+dfsg-2) unstable; urgency=low

  * debian/control:
    - Demoted liblinear1's Recommends for liblinear-tools to Suggests, so
      packages depending only on the library don't pull in the tools.
      Closes: #682062
    - Demoted liblinear-tools' Recommends for libsvm-tools to Suggests, for the
      same reasons. Closes: #679992
    - Bumped Standards-Version to 3.9.5 (no changes needed)
    - Bumped debhelper compatibility version to recommended level 9
    - Dropped dependency on python-support, and added a dependency on
      python-all-dev (>= 2.6.6-3~) for dh_python2, as well as added
      X-Python-Version >= 2.5. Closes: #679993
    - Updated BLAS dependency to libblas-dev | libblas.so, the currently
      recommended approach.
  * debian/compat:
    - Raised debhelper compatibility level to recommended level 9
  * debian/rules:
    - Converted to dh_python2
    - Fixed get-orig-rules target in debian/rules. The generated tarball did
      not match the git version
    - Use DEB_CFLAGS_MAINT_APPEND, as recommended, instead of CFLAGS
  * debian/copyright:
    - Updated to machine-readable copyright format 1.0
  * debian/gbp.conf
    - Created (package is based on dfsg branch, not upstream)
  * debian/patches (new):
     - 0006-Improve-option-parsing
       Use optarg, avoid atoi, verify argument count. Closes: #716115
  * debian/patches (modified):
    - 0001-Properly-build-shared-and-static-libraries-programs
      Include CPPFLAGS to avoid hardening flag warnings
  * debian/source/lintian-overrides:
    - Added override for debian-watch-may-check-gpg-signature
  * debian/*.lintian-overrides:
    - Added overrides for no-upstream-changelog
 -- Christian Kastner <debian@kvr.at>  Wed, 19 Feb 2014 11:21:06 +0100

liblinear (1.8+dfsg-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Added Chen-Tse Tsai <ctse.tsai@gmail.com> to Uploaders
    - Bumped Standards-Version to 3.9.2 (no changes needed)
  * debian/python-liblinear.install
    debian/rules:
    - Dropped the override for dh_install in favor of python-liblinear.install
      Previously, this was not possible because we had to rename files
  * debian/watch:
    - Rewrote version mangling. Now only the upstream version needs to be
      mangled. The previous approach didn't work well together with DEHS
  * debian/copyright:
    - Refreshed upstream's copyright
    - Fixed the previous refresh of my packaging copyright (don't drop 2010)
    - Refreshed DEP5 format to r173
  * debian/python-liblinear.README.Debian
    - Refreshed to reflect that we are now upstream-compatible again
  * debian/patches refreshed:
    - 0001-Properly-build-shared-and-static-libraries-programs
      Fixed a (harmless) missing definition. Also, patch now applies against
      orig tarball created with get-orig-source. The orig tarball previously
      created manually differed slightly (whitespace in Makefile)
  * debian/patches dropped (implemented/included upstream):
    - 0003-Add-missing-solver-to-Python-bindings
    - 0004-Python-namespace-change.patch
  * debian/patches added:
    - 0005-Documentation-fix.patch
      Mismatch between documented formulas

 -- Christian Kastner <debian@kvr.at>  Tue, 05 Apr 2011 14:23:37 +0200

liblinear (1.7+dfsg-1) unstable; urgency=low

  * New upstream release. Closes: #609380
  * python-liblinear:
    - NAMESPACE CHANGE. In anticipation of upstream's namespace switch for the
      next release, our own namespace switch (which broke compatibility) was
      modified to conform to it.
    - Added NEWS file indicating namespace change
    - Updated README.Debian indicating namespace change
  * debian/control:
    - Bumped Standards-Version to 3.9.1 (no changes needed)


=== debian/control ===
--- 
+++ 
@@ -1,26 +1,29 @@
 Source: liblinear
+Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christian Kastner <debian@kvr.at>
+Maintainer: Christian Kastner <debian@kvr.at>
 Uploaders: Chen-Tse Tsai <ctse.tsai@gmail.com>
 Build-Depends:
-    debhelper (>= 7.0.50~),
-    python-all (>= 2.6.6-3~),
+    debhelper (>= 9),
+    dh-python,
+    python-all-dev (>= 2.6.6-3~),
+    python3-all-dev,
     libblas-dev
-Standards-Version: 3.9.2
-Section: libs
+Standards-Version: 3.9.6
 Homepage: http://www.csie.ntu.edu.tw/~cjlin/liblinear/
-Vcs-Git: git://scm.kvr.at/git/pkg-liblinear.git
-Vcs-Browser: http://scm.kvr.at/git/?p=pkg-liblinear.git;a=summary
+Vcs-Git: git://anonscm.debian.org/debian-science/packages/liblinear.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/liblinear.git
 X-Python-Version: >= 2.5
+X-Python3-Version: >= 3.0
 
 Package: liblinear-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends:
     ${misc:Depends},
     liblinear1 (= ${binary:Version}),
-    libblas-dev | libatlas-dev | libblas-3gf.so
+    libblas-dev | libblas.so
 Description: Development libraries and header files for LIBLINEAR
  LIBLINEAR is a library for learning linear classifiers for large scale
  applications. It supports Support Vector Machines (SVM) with L2 and L1
@@ -33,12 +36,14 @@
 
 Package: liblinear1
 Architecture: any
+Multi-Arch: same
+Pre-Depends:
+    ${misc:Pre-Depends}
 Depends:
     ${shlibs:Depends},
     ${misc:Depends}
-Recommends:
-    liblinear-tools (= ${binary:Version})
 Suggests:
+    liblinear-tools (= ${binary:Version}),
     liblinear-dev (= ${binary:Version})
 Description: Library for Large Linear Classification
  LIBLINEAR is a library for learning linear classifiers for large scale
@@ -54,6 +59,7 @@
 Priority: extra
 Section: debug
 Architecture: any
+Multi-Arch: same
 Depends:
     ${misc:Depends},
     liblinear1 (= ${binary:Version}),
@@ -71,6 +77,7 @@
 Package: liblinear-tools
 Section: science
 Architecture: any
+Multi-Arch: foreign
 Depends:
     ${shlibs:Depends},
     ${misc:Depends},
@@ -89,11 +96,12 @@
 
 Package: python-liblinear
 Section: python
-Architecture: any
+Architecture: all
 Depends:
     ${python:Depends},
     ${misc:Depends},
-    liblinear1 (= ${binary:Version})
+    liblinear1 (>= ${binary:Version}),
+    liblinear1 (<< ${binary:Version}.1~)
 Description: Python bindings for LIBLINEAR
  LIBLINEAR is a library for learning linear classifiers for large scale
  applications. It supports Support Vector Machines (SVM) with L2 and L1
@@ -103,3 +111,21 @@
  the fastest SVM solvers around. It also provides Python bindings.
  .
  This package contains the Python bindings.
+
+Package: python3-liblinear
+Section: python
+Architecture: all
+Depends:
+    ${python3:Depends},
+    ${misc:Depends},
+    liblinear1 (>= ${binary:Version}),
+    liblinear1 (<< ${binary:Version}.1~)
+Description: Python 3 bindings for LIBLINEAR
+ LIBLINEAR is a library for learning linear classifiers for large scale
+ applications. It supports Support Vector Machines (SVM) with L2 and L1
+ loss, logistic regression, multi class classification and also Linear
+ Programming Machines (L1-regularized SVMs). Its computational complexity
+ scales linearly with the number of training examples making it one of
+ the fastest SVM solvers around. It also provides Python bindings.
+ .
+ This package contains the Python 3 bindings.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# Path to package source directory 
PKGDIR := $(dir $(firstword $(MAKEFILE_LIST)))..

# Get version numbers for SONAME from changelog
DVER := $(shell cd $(PKGDIR) && dpkg-parsechangelog | grep '^Version')
UPVER := $(shell echo $(DVER) | sed -rne 's/Version: ([^+]+).*/\1/p')
LVER := $(shell echo $(UPVER) | sed -rne 's/([0-9]+)\..*/\1/p')
LSUBVER := $(shell echo $(UPVER) | sed -rne 's/[0-9]+\.([0-9]+)/\1/p')
# Export for upstream's Makefile
export LVER
export LSUBVER

# Get Dpkg version (needed for override_dh_makeshlibs)
DPKGVER := $(shell dpkg -l dpkg-dev | grep '^i' | awk '{print $$3}')

export DEB_CFLAGS_MAINT_APPEND += -Wall
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
ifeq (amd64,$(DEB_HOST_ARCH))
    DEB_CFLAGS_MAINT_APPEND += -msse
endif
endif

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with=python2,python3


override_dh_auto_install:
	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/

# Help out backporters on platforms not supporting c++ tags in symbols files
override_dh_makeshlibs:
	dpkg --compare-versions "$(DPKGVER)" ge "1.15.6" || \
		rm -f debian/liblinear1.symbols
	dh_makeshlibs


override_dh_compress:
	dh_compress -Xexamples


override_dh_strip:
	dh_strip --dbg-package=liblinear-dbg


get-orig-source:
	test -x /usr/bin/unzip || { echo "Package 'unzip' required"; exit 1; }
	
	uscan --noconf --force-download --download-version $(LVER).$(LSUBVER) \
		--check-dirname-level=0 --destdir=$(CURDIR) $(PKGDIR)
	
	unzip liblinear-$(UPVER).zip
	rm -f liblinear-$(UPVER).zip
	
	# Remove Windows binaries
	rm -rf liblinear-$(UPVER)/windows/
	
	# Remove BLAS implementation with unknown license
	rm -rf liblinear-$(UPVER)/blas/
	# matlab Makefile
	sed -i -e '/^\.\.\/blas\/blas\.a:/,+2d' liblinear-$(UPVER)/matlab/Makefile
	sed -i -e 's| ../blas/blas.a||' liblinear-$(UPVER)/matlab/Makefile
	sed -i -e '/blas/d' liblinear-$(UPVER)/matlab/Makefile
	# main Makefile
	sed -i -e '/^/blas\/blas\.a:/,+2d' liblinear-$(UPVER)/Makefile
	sed -i -e 's| blas/blas.a||' liblinear-$(UPVER)/Makefile
	sed -i -e '/blas/d' liblinear-$(UPVER)/Makefile
	
	mv liblinear-$(UPVER) liblinear-$(UPVER).orig
	GZIP="-9" tar --owner=root --group=root --mode=a+rX \
			-czf liblinear_$(UPVER)+dfsg.orig.tar.gz \
			liblinear-$(UPVER).orig
	
	rm -rf liblinear-$(UPVER).orig

=== debian/watch ===
version=3

# Upstream's versioning scheme is 1.5, 1.51, 1.52, etc., so we mangle
# it by adding a 0 to single-digit minor numbers, eg:
# 1.8 -> 1.80, but 1.81 -> 1.81

opts=\
dversionmangle=s/\+dfsg//;s/(\d\.\d)$/${1}0/ \
http://www.csie.ntu.edu.tw/~cjlin/liblinear/oldfiles/liblinear-(.*)\.zip

## liblinear 2.1.0%2Bdfsg

=== Makefile ===
CXX ?= g++
CC ?= gcc
CFLAGS = -Wall -Wconversion -O3 -fPIC
LIBS =
SHVER = 3
OS = $(shell uname)

all: train predict

lib: linear.o tron.o
	if [ "$(OS)" = "Darwin" ]; then \
		SHARED_LIB_FLAG="-dynamiclib -Wl,-install_name,liblinear.so.$(SHVER)"; \
	else \
		SHARED_LIB_FLAG="-shared -Wl,-soname,liblinear.so.$(SHVER)"; \
	fi; \
	$(CXX) $${SHARED_LIB_FLAG} linear.o tron.o -o liblinear.so.$(SHVER)

train: tron.o linear.o train.c
	$(CXX) $(CFLAGS) -o train train.c tron.o linear.o $(LIBS)

predict: tron.o linear.o predict.c
	$(CXX) $(CFLAGS) -o predict predict.c tron.o linear.o $(LIBS)

tron.o: tron.cpp tron.h
	$(CXX) $(CFLAGS) -c -o tron.o tron.cpp

linear.o: linear.cpp linear.h
	$(CXX) $(CFLAGS) -c -o linear.o linear.cpp

clean:
	make -C matlab clean
	rm -f *~ tron.o linear.o train predict liblinear.so.$(SHVER)

## liblinear 2.1.0+dfsg

=== matlab/Makefile ===
# This Makefile is used under Linux

MATLABDIR ?= /usr/local/matlab
CXX ?= g++
#CXX = g++-3.3
CC ?= gcc
CFLAGS = -Wall -Wconversion -O3 -fPIC -I$(MATLABDIR)/extern/include -I..

MEX = $(MATLABDIR)/bin/mex
MEX_OPTION = CC="$(CXX)" CXX="$(CXX)" CFLAGS="$(CFLAGS)" CXXFLAGS="$(CFLAGS)"
# comment the following line if you use MATLAB on a 32-bit computer
MEX_OPTION += -largeArrayDims
MEX_EXT = $(shell $(MATLABDIR)/bin/mexext)

all:	matlab

matlab:	binary

octave:
	@echo "please type make under Octave"
binary: train.$(MEX_EXT) predict.$(MEX_EXT) libsvmread.$(MEX_EXT) libsvmwrite.$(MEX_EXT)

train.$(MEX_EXT): train.c ../linear.h ../tron.o ../linear.o linear_model_matlab.o
	$(MEX) $(MEX_OPTION) train.c ../tron.o ../linear.o linear_model_matlab.o

predict.$(MEX_EXT): predict.c ../linear.h ../tron.o ../linear.o linear_model_matlab.o
	$(MEX) $(MEX_OPTION) predict.c ../tron.o ../linear.o linear_model_matlab.o

libsvmread.$(MEX_EXT):	libsvmread.c
	$(MEX) $(MEX_OPTION) libsvmread.c

libsvmwrite.$(MEX_EXT):	libsvmwrite.c
	$(MEX) $(MEX_OPTION) libsvmwrite.c

linear_model_matlab.o: linear_model_matlab.c ../linear.h
	$(CXX) $(CFLAGS) -c linear_model_matlab.c

../linear.o: ../linear.cpp ../linear.h
	make -C .. linear.o

../tron.o: ../tron.cpp ../tron.h 
	make -C .. tron.o

clean:
	rm -f *~ *.o *.mex* *.obj ../linear.o ../tron.o

=== debian/changelog ===
liblinear (2.1.0+dfsg-4) unstable; urgency=medium

  * Fix copy-pasta in Vcs-* URLs (pointed to wrong project)
  * Move Python build dependencies to Build-Depends-Indep.
    Fixes a FTCBFS. Thanks, Helmut Grohne! Closes: #913244
  * Drop d/*.dirs, the dh_* helpers create directories as needed
  * Move man pages from d/ to d/man
  * Drop cruft liblinear-dbg.lintian-overrides
  * Remove ancient d/python-liblinear.NEWS
    It's content applies to changes before oldoldstable
  * Add Rules-Requires-Root: no

 -- Christian Kastner <ckk@debian.org>  Fri, 15 Feb 2019 15:46:34 +0100

liblinear (2.1.0+dfsg-3) unstable; urgency=medium

  * Point Vcs-* to Salsa
  * Switch to https in Homepage field
  * Switch Build-Depends from debhelper to debhelper-compat
  * Bump Build-Depends for debhelper-compat to 12
  * Remove now obsolete d/compat
  * Drop ancient X-Python{,3}-Version
  * Bump Standards-Version to 4.3.0
  * d/copyright: Switch to https in Format and Source fields
  * d/rules:
    - Drop override_dh_compress
      examples/ aren't compressed in compat 12
    - Use DEB_VERSION_UPSTREAM from dpkg-pkg-info.mk instead of parsing
      d/changelog
    - Drop override_dh_strip
      It was only needed for the dbgsym migration
  * d/liblinear3.symbols: Add Build-Depends-Package field
  * d/tests: Rename ADTTMP to AUTOPKGTEST_TMP
  * gbp.conf:
    - Set upstream-branch to dfsg
    - gbp.conf: Add pristine-tar, sign-tags options
  * d/source/lintian-overrides:
    - Remove tag debian-watch-file-is-missing, it has been re-classified as
      experimental
    - Add tag debian-rules-contains-unnecessary-get-orig-source-target
      False-positive. We do call uscan, but we filter and modify files, so a
      simple File-Excluded in d/copyright won't suffice
  * d/watch:
    - Update to format version 4
    - Switch to https in URL

 -- Christian Kastner <ckk@debian.org>  Thu, 14 Feb 2019 20:13:53 +0100

liblinear (2.1.0+dfsg-2) unstable; urgency=medium

  * Drop package libocas-dbg in favor of automatic dbgsym packages, as per
    https://lists.debian.org/debian-devel/2015/12/msg00262.html
  * d/patches (updated):
    - Properly-build-shared-and-static-libraries-programs.
      Filter out -pie, -fpie, and -fPIE when building the shared library so
      that hardening=+all can be used
  * d/rules:
    - Add hardening=+all to DEB_BUILD_MAINT_OPTIONS
    - Improve version number parsing
  * d/copyright:
    - Bump copyright years
  * d/control:
    - Bump Standards-Version to 3.9.8 (no changes needed)
    - Switch to secure URIs in Vcs-* fields

 -- Christian Kastner <ckk@debian.org>  Sun, 24 Apr 2016 16:55:04 +0200

liblinear (2.1.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Versioning scheme has been changed to better work with upstream's
  * d/control:
    - Build-Depend on python*-all, not python*-all-dev. This was a remnant from
      when the package was still arch:any. Closes: #799231
    - Switch Vcs-Browser from gitweb to cgit
  * d/watch:
    - Redo mangling: Convert upstream version to x.y.z format
  * d/rules:
    - Update get-orig-source for new x.y.z versioning scheme
  * liblinear3:
    - Drop symbol l2r_l2_svc_fun::subXv. No SONAME bump, as this symbol wasn't
      visible outside of experimental
  * d/patches (updated):
    - Properly-build-shared-and-static-libraries-programs.patch
      Makes use of the new versioning scheme

 -- Christian Kastner <ckk@debian.org>  Sun, 01 Nov 2015 17:14:30 +0100

liblinear (2.01+dfsg-1) experimental; urgency=medium

  * New upstream release. Closes: #780528
  * The SONAME was bumped, so rename package liblinear1 to liblinear3
  * d/liblinear3.symbols:
    - Update for the new library version
  * d/control:
    - Switch Maintainer to my @debian.org address
  * d/watch:
    - Update to look for tarball instead of zip
  * d/rules:
    - Simplify upstream version extraction/utilization
    - Update get-orig-source target
    - Use xz compression when repacking the upstream source
    - Drop override_dh_makeshlibs which was only needed for lenny
  * d/copyright:
    - Bump copyright years
  * d/gbp.conf:
    - Update for xz compression
    - Update for patches without numbers
  * d/TODO:
    - Drop, as no open TODOs remain
  * d/liblinear-predict.1
    d/liblinear-train.1:
    - Update manpages
  * d/patches:
    - Drop patch numbers from .patch filenames
  * d/patches (updated):
    - Properly-build-shared-and-static-libraries-programs.patch
    - Improve-option-parsing.patch
  * d/patches (dropped):
    - Documenation-fixes.patch
      Included upstream

 -- Christian Kastner <ckk@debian.org>  Sat, 05 Sep 2015 22:23:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,20 @@
 Source: liblinear
 Section: libs
 Priority: optional
-Maintainer: Christian Kastner <debian@kvr.at>
+Maintainer: Christian Kastner <ckk@debian.org>
 Uploaders: Chen-Tse Tsai <ctse.tsai@gmail.com>
 Build-Depends:
-    debhelper (>= 9),
+    debhelper-compat (= 12),
+    libblas-dev
+Build-Depends-Indep:
     dh-python,
-    python-all-dev (>= 2.6.6-3~),
-    python3-all-dev,
-    libblas-dev
-Standards-Version: 3.9.6
-Homepage: http://www.csie.ntu.edu.tw/~cjlin/liblinear/
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/liblinear.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/liblinear.git
-X-Python-Version: >= 2.5
-X-Python3-Version: >= 3.0
+    python-all (>= 2.6.6-3~),
+    python3-all,
+Rules-Requires-Root: no
+Standards-Version: 4.3.0
+Homepage: https://www.csie.ntu.edu.tw/~cjlin/liblinear/
+Vcs-Git: https://salsa.debian.org/science-team/liblinear.git
+Vcs-Browser: https://salsa.debian.org/science-team/liblinear
 
 Package: liblinear-dev
 Section: libdevel
@@ -22,7 +22,7 @@
 Multi-Arch: same
 Depends:
     ${misc:Depends},
-    liblinear1 (= ${binary:Version}),
+    liblinear3 (= ${binary:Version}),
     libblas-dev | libblas.so
 Description: Development libraries and header files for LIBLINEAR
  LIBLINEAR is a library for learning linear classifiers for large scale
@@ -34,7 +34,7 @@
  .
  This package contains the header files and static libraries.
 
-Package: liblinear1
+Package: liblinear3
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -55,25 +55,6 @@
  .
  This package contains the shared libraries.
 
-Package: liblinear-dbg
-Priority: extra
-Section: debug
-Architecture: any
-Multi-Arch: same
-Depends:
-    ${misc:Depends},
-    liblinear1 (= ${binary:Version}),
-    liblinear-tools (= ${binary:Version})
-Description: Debugging symbols for LIBLINEAR
- LIBLINEAR is a library for learning linear classifiers for large scale
- applications. It supports Support Vector Machines (SVM) with L2 and L1
- loss, logistic regression, multi class classification and also Linear
- Programming Machines (L1-regularized SVMs). Its computational complexity
- scales linearly with the number of training examples making it one of
- the fastest SVM solvers around. It also provides Python bindings.
- .
- This package contains the debugging symbols.
-
 Package: liblinear-tools
 Section: science
 Architecture: any
@@ -81,7 +62,7 @@
 Depends:
     ${shlibs:Depends},
     ${misc:Depends},
-    liblinear1 (= ${binary:Version})
+    liblinear3 (= ${binary:Version})
 Suggests:
     libsvm-tools
 Description: Standalone applications for LIBLINEAR
@@ -100,8 +81,8 @@
 Depends:
     ${python:Depends},
     ${misc:Depends},
-    liblinear1 (>= ${binary:Version}),
-    liblinear1 (<< ${binary:Version}.1~)
+    liblinear3 (>= ${binary:Version}),
+    liblinear3 (<< ${binary:Version}.1~)
 Description: Python bindings for LIBLINEAR
  LIBLINEAR is a library for learning linear classifiers for large scale
  applications. It supports Support Vector Machines (SVM) with L2 and L1
@@ -118,8 +99,8 @@
 Depends:
     ${python3:Depends},
     ${misc:Depends},
-    liblinear1 (>= ${binary:Version}),
-    liblinear1 (<< ${binary:Version}.1~)
+    liblinear3 (>= ${binary:Version}),
+    liblinear3 (<< ${binary:Version}.1~)
 Description: Python 3 bindings for LIBLINEAR
  LIBLINEAR is a library for learning linear classifiers for large scale
  applications. It supports Support Vector Machines (SVM) with L2 and L1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# For DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

# Needed for our Makefile customizations, and for get-orig-source
DMAJOR := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -rne 's/([0-9])\.[0-9]\.[0-9].*/\1/p')
DMINOR := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -rne 's/[0-9]\.([0-9])\.[0-9].*/\1/p')
DPATCH := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -rne 's/[0-9]\.[0-9]\.([0-9]).*/\1/p')
# Replicate upstream's naming convention... (see d/watch)
ifeq ($(DPATCH),0)
    UPVER := $(DMAJOR).$(DMINOR)
else
    UPVER := $(DMAJOR).$(DMINOR)$(DPATCH)
endif
export UPVER DEBVER DMAJOR DMINOR DPATCH


export DEB_BUILD_MAINT_OPTIONS += hardening=+all
export DEB_CFLAGS_MAINT_APPEND += -Wall

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
ifeq (amd64,$(DEB_HOST_ARCH))
    DEB_CFLAGS_MAINT_APPEND += -msse
endif
endif

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


%:
	dh $@ $(DH_ADDONS)
build binary %-indep: DH_ADDONS=--with=python2,python3


override_dh_auto_install:
	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/


get-orig-source:
	test -x /usr/bin/unzip || { echo "Package 'unzip' required"; exit 1; }
	
	uscan \
		--noconf \
		--no-symlink \
		--force-download \
		--download-version $(DEBVER) \
		--check-dirname-level=0 \
		--destdir=$(CURDIR) \
		$(PKGDIR)
	
	tar -xzf liblinear-$(UPVER).tar.gz
	rm -f liblinear-$(UPVER).tar.gz
	
	# Remove Windows binaries
	rm -rf liblinear-$(UPVER)/windows/
	
	# Remove BLAS implementation with unknown license
	rm -rf liblinear-$(UPVER)/blas/
	# matlab Makefile
	sed -i -e '/^\.\.\/blas\/blas\.a:.*/,+2d' liblinear-$(UPVER)/matlab/Makefile
	sed -i -e 's| ../blas/blas.a||' liblinear-$(UPVER)/matlab/Makefile
	sed -i -e '/blas/d' liblinear-$(UPVER)/matlab/Makefile
	# main Makefile
	sed -i -e '/^blas\/blas\.a:.*/,+2d' liblinear-$(UPVER)/Makefile
	sed -i -e 's| blas/blas.a||' liblinear-$(UPVER)/Makefile
	sed -i -e '/blas/d' liblinear-$(UPVER)/Makefile
	
	mv liblinear-$(UPVER) liblinear-$(DEBVER)+dfsg
	tar \
		--owner=root \
		--group=root \
		--mode=a+rX \
		--xz \
		-cf liblinear_$(DEBVER)+dfsg.orig.tar.xz \
		liblinear-$(DEBVER)+dfsg
	
	rm -rf liblinear-$(DEBVER)+dfsg

=== debian/watch ===
version=4

# Upstream's versioning scheme is 1.0, 1.01, 1.1, 1.11, 1.12, etc., so we
# mangle it by converting it to x.y.z pattern:
#  1.0   -> 1.0.0
#  1.01  -> 1.0.1
#  1.1   -> 1.1.0
#  1.11  -> 1.1.1
#  1.12  -> 1.1.2
#  etc

opts=\
uversionmangle=s/(\d\.\d)$/${1}0/;s/(\d)\.(\d)(\d)/${1}\.${2}\.${3}/,\
dversionmangle=s/\+dfsg// \
https://www.csie.ntu.edu.tw/~cjlin/liblinear/oldfiles/liblinear-(.*)\.tar\.gz

## liblinear 2.3.0%2Bdfsg

=== debian/changelog ===
liblinear (2.3.0+dfsg-5) UNRELEASED; urgency=medium

  * update

 -- Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>  Thu, 19 May 2022 10:16:22 +0800

liblinear (2.3.0+dfsg-5) unstable; urgency=medium

  * d/tests/control: Add python3-all to python3-simple's Depends:.
    (Closes: #972532)
  * Add myself to uploaders. 

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Thu, 22 Oct 2020 08:13:03 +1300

liblinear (2.3.0+dfsg-4) unstable; urgency=medium

  * Add autopkgtest for Python package
  * Add patch Merge-commonutil.py-into-liblinearutil.py.patch (Closes: #958641)
    - Add python3-liblinear.README.Debian documenting the merge
  * Bump Standards-Version to 4.5.0 (no changes needed)

 -- Christian Kastner <ckk@debian.org>  Sat, 02 May 2020 10:10:18 +0200

liblinear (2.3.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Packages in Debian Science team should be maintained by
    <debian-science-maintainers@lists.alioth.debian.org>
  * Drop Python2 package (addresses: #936889)
  * Rely on pre-initialized dpkg-architecture variables.

 -- Andreas Tille <tille@debian.org>  Sat, 21 Dec 2019 08:12:33 +0100

liblinear (2.3.0+dfsg-2) unstable; urgency=medium

  * gbp.conf: Drop upstream-tag remnant from earlier setup

 -- Christian Kastner <ckk@debian.org>  Thu, 31 Oct 2019 10:57:42 +0100

liblinear (2.3.0+dfsg-1) experimental; urgency=medium

  * New upstream release.
    - Bump SONAME from 3 to 4
      The new release contains backwards-incompatible changes to the API
    - Refresh manpages

  * d/control: Bump Standards-Version to 4.4.1 (no changes needed)
  * d/copyright:
    - Improve DFSG note in Comments
    - Add Files-Excluded for generating DFSG-cleaned sources
    - Bump copyrights
  * d/rules:
    - Override_dh_missing for --fail-missing
    - Drop now superfluous get-orig-source target
  * Update symbols file
  * d/patches:
    - Add Bump-SONAME.patch
    - Refresh patch Improve-option-parsing.patch
    - Add patch Get-rid-of-bundled-BLAS.patch
  * d/watch: Add repacksuffix=+dfsg
  * Drop now superfluous d/source/lintian-overrides
  * gbp.conf: Get rid of "dfsg" branch; use "upstream" directly
  * Let dh_install install from debian/tmp, instead of source.
    Resolves a warning from dh_missing. Thanks, Niels Thykier, for the analysis and
    resolution!

 -- Christian Kastner <ckk@debian.org>  Tue, 22 Oct 2019 13:00:10 +0200

## liblinear 2.3.0+dfsg

=== Makefile ===
CXX ?= g++
CC ?= gcc
CFLAGS = -Wall -Wconversion -O3 -fPIC
LIBS = blas/blas.a
SHVER = 3
OS = $(shell uname)
#LIBS = -lblas

all: train predict

lib: linear.o tron.o blas/blas.a
	if [ "$(OS)" = "Darwin" ]; then \
		SHARED_LIB_FLAG="-dynamiclib -Wl,-install_name,liblinear.so.$(SHVER)"; \
	else \
		SHARED_LIB_FLAG="-shared -Wl,-soname,liblinear.so.$(SHVER)"; \
	fi; \
	$(CXX) $${SHARED_LIB_FLAG} linear.o tron.o blas/blas.a -o liblinear.so.$(SHVER)

train: tron.o linear.o train.c blas/blas.a
	$(CXX) $(CFLAGS) -o train train.c tron.o linear.o $(LIBS)

predict: tron.o linear.o predict.c blas/blas.a
	$(CXX) $(CFLAGS) -o predict predict.c tron.o linear.o $(LIBS)

tron.o: tron.cpp tron.h
	$(CXX) $(CFLAGS) -c -o tron.o tron.cpp

linear.o: linear.cpp linear.h
	$(CXX) $(CFLAGS) -c -o linear.o linear.cpp

blas/blas.a: blas/*.c blas/*.h
	make -C blas OPTFLAGS='$(CFLAGS)' CC='$(CC)';

clean:
	make -C blas clean
	make -C matlab clean
	rm -f *~ tron.o linear.o train predict liblinear.so.$(SHVER)

=== matlab/Makefile ===
# This Makefile is used under Linux

MATLABDIR ?= /usr/local/matlab
CXX ?= g++
#CXX = g++-3.3
CC ?= gcc
CFLAGS = -Wall -Wconversion -O3 -fPIC -I$(MATLABDIR)/extern/include -I..

MEX = $(MATLABDIR)/bin/mex
MEX_OPTION = CC="$(CXX)" CXX="$(CXX)" CFLAGS="$(CFLAGS)" CXXFLAGS="$(CFLAGS)"
# comment the following line if you use MATLAB on a 32-bit computer
MEX_OPTION += -largeArrayDims
MEX_EXT = $(shell $(MATLABDIR)/bin/mexext)

all:	matlab

matlab:	binary

octave:
	@echo "please type make under Octave"
binary: train.$(MEX_EXT) predict.$(MEX_EXT) libsvmread.$(MEX_EXT) libsvmwrite.$(MEX_EXT)

train.$(MEX_EXT): train.c ../linear.h ../tron.cpp ../linear.cpp linear_model_matlab.c \
		../blas/daxpy.c ../blas/ddot.c ../blas/dnrm2.c ../blas/dscal.c
	$(MEX) $(MEX_OPTION) train.c ../tron.cpp ../linear.cpp linear_model_matlab.c \
		../blas/daxpy.c ../blas/ddot.c ../blas/dnrm2.c ../blas/dscal.c

predict.$(MEX_EXT): predict.c ../linear.h ../tron.cpp ../linear.cpp linear_model_matlab.c \
		../blas/daxpy.c ../blas/ddot.c ../blas/dnrm2.c ../blas/dscal.c
	$(MEX) $(MEX_OPTION) predict.c ../tron.cpp ../linear.cpp linear_model_matlab.c \
		../blas/daxpy.c ../blas/ddot.c ../blas/dnrm2.c ../blas/dscal.c

libsvmread.$(MEX_EXT):	libsvmread.c
	$(MEX) $(MEX_OPTION) libsvmread.c

libsvmwrite.$(MEX_EXT):	libsvmwrite.c
	$(MEX) $(MEX_OPTION) libsvmwrite.c

clean:
	rm -f *~ *.o *.mex* *.obj

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: liblinear
 Section: libs
 Priority: optional
-Maintainer: Christian Kastner <ckk@debian.org>
-Uploaders: Chen-Tse Tsai <ctse.tsai@gmail.com>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Christian Kastner <ckk@debian.org>,
+           Chen-Tse Tsai <ctse.tsai@gmail.com>,
+           Michael Hudson-Doyle <mwhudson@debian.org>
 Build-Depends:
     debhelper-compat (= 12),
     libblas-dev
 Build-Depends-Indep:
     dh-python,
-    python-all (>= 2.6.6-3~),
     python3-all,
 Rules-Requires-Root: no
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://www.csie.ntu.edu.tw/~cjlin/liblinear/
 Vcs-Git: https://salsa.debian.org/science-team/liblinear.git
 Vcs-Browser: https://salsa.debian.org/science-team/liblinear
@@ -22,7 +23,7 @@
 Multi-Arch: same
 Depends:
     ${misc:Depends},
-    liblinear3 (= ${binary:Version}),
+    liblinear4 (= ${binary:Version}),
     libblas-dev | libblas.so
 Description: Development libraries and header files for LIBLINEAR
  LIBLINEAR is a library for learning linear classifiers for large scale
@@ -34,7 +35,7 @@
  .
  This package contains the header files and static libraries.
 
-Package: liblinear3
+Package: liblinear4
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -62,7 +63,7 @@
 Depends:
     ${shlibs:Depends},
     ${misc:Depends},
-    liblinear3 (= ${binary:Version})
+    liblinear4 (= ${binary:Version})
 Suggests:
     libsvm-tools
 Description: Standalone applications for LIBLINEAR
@@ -75,32 +76,14 @@
  .
  This package contains the standalone applications.
 
-Package: python-liblinear
-Section: python
-Architecture: all
-Depends:
-    ${python:Depends},
-    ${misc:Depends},
-    liblinear3 (>= ${binary:Version}),
-    liblinear3 (<< ${binary:Version}.1~)
-Description: Python bindings for LIBLINEAR
- LIBLINEAR is a library for learning linear classifiers for large scale
- applications. It supports Support Vector Machines (SVM) with L2 and L1
- loss, logistic regression, multi class classification and also Linear
- Programming Machines (L1-regularized SVMs). Its computational complexity
- scales linearly with the number of training examples making it one of
- the fastest SVM solvers around. It also provides Python bindings.
- .
- This package contains the Python bindings.
-
 Package: python3-liblinear
 Section: python
 Architecture: all
 Depends:
     ${python3:Depends},
     ${misc:Depends},
-    liblinear3 (>= ${binary:Version}),
-    liblinear3 (<< ${binary:Version}.1~)
+    liblinear4 (>= ${binary:Version}),
+    liblinear4 (<< ${binary:Version}.1~)
 Description: Python 3 bindings for LIBLINEAR
  LIBLINEAR is a library for learning linear classifiers for large scale
  applications. It supports Support Vector Machines (SVM) with L2 and L1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# For DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

# Needed for our Makefile customizations
DMAJOR := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -rne 's/([0-9])\.[0-9]\.[0-9].*/\1/p')
DMINOR := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -rne 's/[0-9]\.([0-9])\.[0-9].*/\1/p')
DPATCH := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -rne 's/[0-9]\.[0-9]\.([0-9]).*/\1/p')
# Replicate upstream's naming convention... (see d/watch)
ifeq ($(DPATCH),0)
    UPVER := $(DMAJOR).$(DMINOR)
else
    UPVER := $(DMAJOR).$(DMINOR)$(DPATCH)
endif
export UPVER DEBVER DMAJOR DMINOR DPATCH


export DEB_BUILD_MAINT_OPTIONS += hardening=+all
export DEB_CFLAGS_MAINT_APPEND += -Wall

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
ifeq (amd64,$(DEB_HOST_ARCH))
    DEB_CFLAGS_MAINT_APPEND += -msse
endif
endif

include /usr/share/dpkg/architecture.mk


%:
	dh $@ $(DH_ADDONS)
build binary %-indep: DH_ADDONS=--with=python3


override_dh_auto_install:
	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/

override_dh_missing:
	dh_missing --fail-missing

=== debian/tests/control ===
Tests: executables
Depends: liblinear-tools

Tests: python3-simple
Depends: python3-all, python3-liblinear
